TB/Informatique/MCA/MCA/urls.py
from django.contrib import admin
from django.urls import include, path

from . import views

urlpatterns = [
    path('', views.index, name='index'),
    path('chargeur/', include('chargeur.urls')),
    path('admin/', admin.site.urls),
]

TB/Informatique/MCA/chargeur/urls.py
from django.urls import path, register_converter

from . import views

app_name = 'chargeur'
urlpatterns = [
    #//ex: /chargeur/
    path('new/', views.index, name='index'),
    path('start/', views.start_load, name='loading_start'),
    path('stop/', views.stop_load, name='loading_stop'),
    path('reset/', views.reset_load, name='loading_reset'),
    path('send/', views.send, name='send'),
    path('setting/<int:setting_id>/', views.index_load, name='index_load'),
    path('', views.load, name='load'),
    path('recipe/', views.recipe, name='recipe'),
    path('recipe/<int:recipe_id>/', views.recipe_detail, name='recipe_detail'),
    path('recipe/load/', views.load_recipe, name='load_recipe'),
    path('stats/', views.stats, name='stats'),
    path('error/', views.error, name='error'),
    path('error/all/', views.error_all, name='error_all'),
    path('error/<int:error_id>/', views.error_detail, name='error_detail'),
]

TB/Informatique/MCA/chargeur/forms.py
from django.forms import ModelForm, ModelChoiceField, Textarea
from django.utils.translation import gettext_lazy as _
from .models import Recipe, Setting

#Form for Setting model
class SettingForm(ModelForm):
    #Redefine init for value verification
    def __init__(self, *args, **kwargs):
        super(SettingForm, self).__init__(*args, **kwargs)
        #Length between 40 and 200
        self.fields['tube_length'].widget.attrs['min'] = 40
        self.fields['tube_length'].widget.attrs['max'] = 200
        #Diameter between 1 and 50
        self.fields['tube_width'].widget.attrs['min'] = 1
        self.fields['tube_width'].widget.attrs['max'] = 50
        #Loading offset above 10
        self.fields['loading_offset'].widget.attrs['min'] = 10

    #Optional Choice Field
    recipe = ModelChoiceField(queryset=Recipe.objects.all(), required=False)

    class Meta:
        model = Setting
        fields = ['setting_name','tube_width','tube_length','loading_offset','recipe']
        labels = {
            'setting_name' : _('Name'),
            'tube_length' : _('Length of tube'),
            'tube_width' : _('Diameter of tube'),
            'loading_offset' : _('Distance offset'),
            'recipe' : _('Recipe'),
        }

#Form for Recipe model
class RecipeForm(ModelForm):
    #Redefine init for value verification
    def __init__(self, *args, **kwargs):
        super(RecipeForm, self).__init__(*args, **kwargs)
        #Crit Speed between 1 and 240
        self.fields['crit_low_speed'].widget.attrs['min'] = 1
        self.fields['crit_low_speed'].widget.attrs['max'] = 240
        #Charging factor between 1 and 5
        self.fields['charging_factor_below_speed'].widget.attrs['min'] = 1
        self.fields['charging_factor_below_speed'].widget.attrs['max'] = 5
        #Wait time between 0 and 360
        self.fields['wait_time_below_speed'].widget.attrs['min'] = 0
        self.fields['wait_time_below_speed'].widget.attrs['max'] = 360
        #Conveyor speed above 0
        self.fields['conveyor_speed_correction'].widget.attrs['min'] = 0
        #Allowed speed change between 0 and 100
        self.fields['allowed_speed_change'].widget.attrs['min'] = 0
        self.fields['allowed_speed_change'].widget.attrs['max'] = 100
        #Start Offset between 0 and 360
        self.fields['start_offset_angle'].widget.attrs['min'] = 0
        self.fields['start_offset_angle'].widget.attrs['max'] = 360
        #Loading factor between 0 and 1
        self.fields['loading_marging_factor'].widget.attrs['min'] = 0
        self.fields['loading_marging_factor'].widget.attrs['max'] = 1
        #Pos angle between 10 and 50
        self.fields['allowed_pos_angle_error'].widget.attrs['min'] = 10
        self.fields['allowed_pos_angle_error'].widget.attrs['max'] = 50
        #Neg angle between -50 and -10
        self.fields['allowed_neg_angle_error'].widget.attrs['min'] = -50
        self.fields['allowed_neg_angle_error'].widget.attrs['max'] = -10

    class Meta:
        model = Recipe
        fields = '__all__'
        labels = {
            'recipe_name' : _('Recipe name'),
            'crit_low_speed' : _('Critical low speed value'),
            'charging_factor_below_speed' : _('Charging speed factor below critical speed'),
            'wait_time_below_speed' : _('Wait time below critical speed'),
            'conveyor_speed_correction' : _('Speed correction on conveyor'),
            'allowed_speed_change' : _('Allowed speed change (in %)'),
            'start_offset_angle' : _('Start offset angle'),
            'loading_marging_factor' : _('Loading marging factor'),
            'allowed_pos_angle_error' : _('Positive angle error allowed'),
            'allowed_neg_angle_error' : _('Negative angle error allowed'),
        }

TB/Informatique/MCA/chargeur/views.py
import chargeur
from django.shortcuts import get_object_or_404, render, redirect
from django.utils import timezone
from django.http import  HttpRequest
from django.contrib import messages
from django.db.models import Avg, Min

from .models import Recipe, Setting, Error, Chain_Data, Axis_Data, Other_Data, Automate_Data
from .forms import RecipeForm, SettingForm

import asyncio
import sys
import logging
import concurrent.futures
from asyncua import Client, Node, ua

#OPC-UA Server address
url = 'opc.tcp://169.254.11.22:4840'

#Automate State Machines
states = ["INIT", "STOP", "DETECT_CHAIN", "CALC_CAM", "RESET_AXIS", "START_SYNCH", "READY", "STARTING", "RUN", "STOPING", "RESTART", "WAIT", "EMERGENCY_STOP","ERROR","DISCONNECTED",]
errors = ["NO_ERROR","SYNCH_ERROR","CHAIN_NOT_STABLE","NOT_STOP","DISJONCTEUR_OFF","DISJONCTEUR_24V_OFF", "Error_FREQVAR_Conveyor"]

#Arrays with information concerning automate errors
errors_name = [
    "No error",
    "Failed to synchronise",
    "Chain not stable",
    "Emergency button",
    "Breaker popped",
    "24V Breaker popped",
    "Conveyor frequency converter error"
]
errors_desc = [
    "No error occurred",
    "Automate did not manage to synchronise with the chain",
    "Speed of chain changed above threshold",
    "Emergency stop button pressed",
    "The top breaker popped to prevent issues",
    "The 24V breaker popped to prevent issues",
    "There was a problem with the conveyor's frequency converter. Could not control anymore",
]
errors_type = ['1', '1', '1', '5', '5', '5', '4']

#String to simplify node naming
node_prefix = "ns=2;s=unit/"
CC = "Calculate_CAM."
SSM = "Sequencer_State_Machine."
MAS = "Master_axis_Synch."
CD = "Chain_Detection."

"""
Creates a new Error instance, and insert it into database
@param name : Name of the error,
       desc : Description of the error,
       type: serioussness of the error
"""
def _create_error(name, desc, type):
    Error.objects.create(error_name=name, error_description=desc, alert_type=type)

"""
Check if an error occurred in automate, and insert it into DB if there is
"""
async def check_for_error():
    try:
        #Connect to the OPC-UA Server
        async with Client(url=url) as client:
            #Check Flag for error
            var = client.get_node(node_prefix +"ERROR_HANDLE.Error_Flag")
            error = await var.read_value()
            if error:
                #Get error and insert it into DB
                var1 = client.get_node(node_prefix + "ERROR_HANDLE.ERROR_VALUE")
                error = await var1.read_value()
                loop = get_or_create_event_loop()
                await loop.run_in_executor(None, _create_error, errors_name[error], errors_desc[error], errors_type[error])
                #Reset flag to false
                await var.write_value(False)
    except Exception as err:
        #Insert exception into DB
        loop = get_or_create_event_loop()
        await loop.run_in_executor(None, _create_error, type(err).__name__ + " (Checking for error)", str(err), '1')

"""
Get event loop, or create new one if no loop.
Used to convert async to sync, or sync to async
@return event_loop
"""
def get_or_create_event_loop():
    try:
        return asyncio.get_event_loop()
    except RuntimeError as ex:
        if "There is no current event loop in thread" in str(ex):
            loop = asyncio.new_event_loop()
            asyncio.set_event_loop(loop)
            return asyncio.get_event_loop()

"""
Get value of calculated variables from automate
@return chain_data, axis_data, other_data : data concerning chain,axis and other sources
"""
async def read_working_data():
    try:
        await check_for_error()
        #connect to automate
        async with Client(url=url) as client:
            #Read data from chain, and instanciate a Chain_Data
            var1 = client.get_node(node_prefix + CC +"Chain_speed")
            var2 = client.get_node(node_prefix + CC +"tube_p_min")
            chain_data = Chain_Data()
            chain_data.speed = round(await var1.read_value(),2)
            chain_data.pace = round(await var2.read_value(),2)
            #Read data from axis, and instanciate an Axis_Data
            var3 = client.get_node(node_prefix + CC +"Master_degs")
            var4 = client.get_node(node_prefix + CC +"Master_cam_start")
            var5 = client.get_node(node_prefix + CC +"Master_cam_deg")
            var6 = client.get_node(node_prefix + CC +"Following_cam_deg")
            axis_data = Axis_Data()
            axis_data.angular_speed = round(await var3.read_value(),2)
            axis_data.start_angle = round(await var4.read_value(),2)
            axis_data.master_deg = round(await var5.read_value(),2)
            axis_data.slave_deg = round(await var6.read_value(),2)
            #Read data from other sources, and instanciate an Other_Data
            var7 = client.get_node(node_prefix + CC +"Insertion_time")
            var8 = client.get_node(node_prefix + CC +"Mean_t_between")
            var9 = client.get_node(node_prefix + CC +"Mean_t_full")
            var10 = client.get_node(node_prefix + CC +"Conveyor_speed_cmd")
            other_data = Other_Data()
            other_data.insert_time = round(await var7.read_value()*1000,2)
            other_data.time_between = round(await var8.read_value(),2)
            other_data.time_full = round(await var9.read_value(),2)
            other_data.conveyor_speed = round(await var10.read_value(),2)
            return chain_data, axis_data, other_data
    except Exception as err:
        #Insert exception into DB
        loop = get_or_create_event_loop()
        await loop.run_in_executor(None, _create_error, type(err).__name__ + " (Reading Data)", str(err),'2')
        return False, False, False

"""
Main page, create new Setting form
@param request: Request to handle
@return HttpResponse page with data
"""
def index(request):
    active = 'index'
    #Create form
    form = SettingForm(request.POST or None)
    #Get current automate state
    loop = get_or_create_event_loop()
    coroutine = get_current_state()
    machine_state = loop.run_until_complete(coroutine)
    #Get data
    loop = get_or_create_event_loop()
    coroutine = read_working_data()
    chain, axis, other = loop.run_until_complete(coroutine)
    if request.method == 'POST':      #Form button
        if 'save' in request.POST:    #New Setting
            if form.is_valid():
                #Save new setting in DB, and notify user
                form.save()
                messages.info(request, 'Setting has been successfully added')
                return redirect('chargeur:index')
        elif 'send' in request.POST:  #Send to automate
            if form.is_valid():
                #Can only send if in INIT or STOP state
                if machine_state <= states.index("STOP"):
                    try:
                         #Send Setting and notify user
                         loop = get_or_create_event_loop()
                         coroutine = send(form.cleaned_data)
                         loop.run_until_complete(coroutine)
                         messages.info(request, 'Setting has been successfully sent')
                    except Exception as err:
                         _create_error(type(err).__name__ + " (Sending Parameter)", str(err), '3')
                         messages.info(request, 'Could not connect to automate')
                else:
                    messages.info(request, 'Incorrect state: cannot send data')
                return redirect('chargeur:index')
        elif 'data' in request.POST:  #Save Data
            #Save Chain, Axis and Other_Data, create and save Automate_Data
            chain.save()
            axis.save()
            other.save()
            data = Automate_Data(chain=chain, axis=axis, other=other)
            data.save()
            messages.info(request, 'Data has been successfully saved')
            return redirect('chargeur:index')
    #Data sent to template
    context = {
        'new' : True,
        'active' : active,
        'form': form,
        'machine_state': states[machine_state],
        'start_button' : start_button_ok(machine_state),
        'stop_button' : stop_button_ok(machine_state),
        'reset_button' : reset_button_ok(machine_state),
        'synchro_state' : synchronization_state(machine_state),
        'loading_state' : loading_state(machine_state),
        'chain' : chain,
        'axis' : axis,
        'other' : other,
        }
    return render(request, 'chargeur/index.html', context)

"""
Send Setting to automate
@param data: cleaned data from Setting Form,
       recipe: optionnal recipe to send with Setting
"""
async def send(data, recipe):
    await check_for_error()
    #Send recipe if it exists
    if recipe:
        await send_recipe_instance(data['recipe'])
    #Connect to automate
    async with Client(url=url) as client:
        #Get node from variable to write into
        var1 = client.get_node(node_prefix + CC + "Tube_length_mm")
        var2 = client.get_node(node_prefix + CC + "Tube_dia_mm")
        var3 = client.get_node(node_prefix + CC + "Loading_offset_tube")
        #Write value into variables
        await var1.write_value(ua.Variant([data['tube_length']], ua.VariantType.Float))
        await var2.write_value(ua.Variant([data['tube_width']], ua.VariantType.Float))
        await var3.write_value(ua.Variant([data['loading_offset']], ua.VariantType.Float))

"""
Get the current state the automate is in
@return state : State of the automate
"""
async def get_current_state():
    try:
        await check_for_error()
        #Connect to automate
        async with Client(url=url) as client:
            #Read value from state variable
            var = client.get_node(node_prefix + SSM +"Current_State")
            state = await var.read_value()
        return state
    except Exception as err:
        #Insert exception into DB

TB/Informatique/MCA/chargeur/templates/chargeur/error.html
{% include "chargeur/navbar.html" %}
<h2>Errors</h2>
<div class="container-fluid">
            <a class="btn btn-primary" role="button" {% if all %} href="{% url 'chargeur:error'%}">Display unack errors{% else %} href="{% url 'chargeur:error_all' %}"> Display all errrors {% endif %}</a>
    <div class="row">
        <div class="col">
            <h4>Warning</h4>
            {% if warning_list %}
                <ul class="error">
                {% for error in warning_list %}
                    <li>
                        <a href="{% url 'chargeur:error_detail' error.id %}">
                        <b>{{ error.timestamp|date:"D d/m/Y - H:i:s" }}</b><br>
                        {{error.error_name}}
                        </a>
                    </li>
                {% endfor %}
                </ul>
            {% else %}
                <p>No warnings available.</p>
            {% endif %}
        </div>
        <div class="col">
            <h4>Low</h4>
            {% if low_list %}
                <ul class="error">
                {% for error in low_list %}
                    <li>
                        <a href="{% url 'chargeur:error_detail' error.id %}">
                        <b>{{ error.timestamp|date:"D d/m/Y - H:i:s" }}</b><br>
                        {{error.error_name}}
                        </a>
                    </li>
                {% endfor %}
                </ul>
            {% else %}
                <p>No error available.</p>
            {% endif %}
        </div>
        <div class="col">
            <h4>Medium</h4>
            {% if medium_list %}
                <ul class="error">
                {% for error in medium_list %}
                    <li>
                        <a href="{% url 'chargeur:error_detail' error.id %}">
                        <b>{{ error.timestamp|date:"D d/m/Y - H:i:s" }}</b><br>
                        {{error.error_name}}
                        </a>
                    </li>
                {% endfor %}
                </ul>
            {% else %}
                <p>No error available.</p>
            {% endif %}
        </div>
        <div class="col">
            <h4>High</h4>
            {% if high_list %}
                <ul class="error">
                {% for error in high_list %}
                    <li>
                        <a href="{% url 'chargeur:error_detail' error.id %}">
                        <b>{{ error.timestamp|date:"D d/m/Y - H:i:s" }}</b><br>
                        {{error.error_name}}
                        </a>
                    </li>
                {% endfor %}
                </ul>
            {% else %}
                <p>No error available.</p>
            {% endif %}
        </div>
        <div class="col">
            <h4>Critical</h4>
            {% if critical_list %}
                <ul class="error">
                {% for error in critical_list%}
                    <li>
                        <a href="{% url 'chargeur:error_detail' error.id %}">
                        <b>{{ error.timestamp|date:"D d/m/Y - H:i:s" }}</b><br>
                        {{error.error_name}}
                        </a>
                    </li>
                {% endfor %}
                </ul>
            {% else %}
                <p>No error available.</p>
            {% endif %}
        </div>
    </div>
</div>

TB/Informatique/MCA/chargeur/templates/chargeur/index.html
{% include "chargeur/navbar.html" %}
{% load bootstrap4 %}
{% bootstrap_css %}
{% bootstrap_javascript jquery='full' %}
<div class="container-fluid">
    <div class="row">
        <div class="col-8">
            <h2>Data</h2>
            {% if machine_state == 'READY' or machine_state == 'STARTING' or machine_state == 'RUN' or machine_state == 'STOPING' %}
            <div class="row">
                <div class="col-3">
                    <h3>Chain values</h3>
                    {% if chain %}
                    <table>
                        <tbody>
                            <tr>
                                <th>Chain speed: </th>
                                <td>{{chain.speed}}mm/s</td>
                            </tr>
                            <tr>
                                <th>Pace: </th>
                                <td>{{chain.pace}} tube/min</td>
                            </tr>
                        </tbody>
                    </table>
                    {% else %}
                    Cannot connect
                    {% endif %}
                </div>
                <div class="col-5">
                    <h3>Axis values</h3>
                    {% if axis %}
                    <table>
                        <tbody>
                            <tr>
                                <th>Master speed: </th>
                                <td>{{axis.angular_speed}}°/s</td>
                            </tr>
                            <tr>
                                <th>Master start offset angle: </th>
                                <td>{{axis.start_angle}}°</td>
                            </tr>
                            <tr>
                                <th>When master is at {{axis.master_deg}}°</th>
                                <td>Slave must be at {{axis.slave_deg}}°</td>
                            </tr>
                        </tbody>
                    </table>
                    {% else %}
                    Cannot connect
                    {% endif %}
                </div>
                <div class="col-4">
                    <h3>Other values</h3>
                    {% if other %}
                    <table>
                        <tbody>
                            <tr>
                                <th>Insertion time: </th>
                                <td>{{other.insert_time}}ms</td>
                            </tr>
                            <tr>
                                <th>Time between each sensor: </th>
                                <td>{{other.time_between}}ms</td>
                            </tr>
                            <tr>
                                <th>Time between each insertion: </th>
                                <td>{{other.time_full}}ms</td>
                            </tr>
                            <tr>
                                <th>Conveyor speed command: </th>
                                <td>{{other.conveyor_speed}}mm/s</td>
                            </tr>
                        </tbody>
                    </table>
                    {% else %}
                    Cannot connect
                    {% endif %}
                </div>
            </div>
            <form action="" method="POST">
                {% csrf_token %}
                <input type="submit" name="data" class="btn btn-primary" value="Save Data">
            </form>
            {% else %}
                <b> Cannot display data until automate is synchronized</b> 
            {% endif %}
        </div>
        <div class="col-4">
            <h2>Status</h2>
 	    Current state: {{machine_state}}<br>
            {% if synchro_state == 'green' %}
            Automate is synchronized : 
            {% elif synchro_state == 'orange' %}
            Automate is synchronizing :
            {% else %}
            Automate is not synchronized : 
            {% endif %}
            <span class="dot {{synchro_state}}"> </span><br>
            {% if loading_state == 'green' %}
            Automate is loading : 
            {% elif loading_state == 'orange' %}
            Automate is ready to load :
            {% else %}
            Automate cannot start loading : 
            {% endif %}
            <span class="dot {{loading_state}}"></span><br>
            <a class="btn {% if start_button %} btn-success {% else %} btn_secondary disabled {% endif %}" href="{% url 'chargeur:loading_start' %}" role="button"{% if not start_button %}  aria-disabled="true" {% endif %}>Start</a>
            <a class="btn {% if stop_button %} btn-danger {% else %} btn_secondary disabled {% endif %}" href="{% url 'chargeur:loading_stop' %}" role="button" {% if not stop_button %}  aria-disabled="true" {% endif %}>Stop</a>
            <a class="btn {% if reset_button %} btn-primary {% else %} btn_secondary disabled {% endif %}" href="{% url 'chargeur:loading_reset' %}" role="button" {% if not reset_button %}  aria-disabled="true" {% endif %}>Reset</a>
            <h2>Parameters</h2>
            {% if new %} 
            <a class="btn btn-primary" href="{% url 'chargeur:load' %}" role="button">Load</a>
            {% else %}
            <a class="btn btn-primary" href="{% url 'chargeur:index' %}" role="button">New</a>
            {% endif %}
            {% if form %}
            <a class="btn btn-secondary" href="{% url 'chargeur:load' %}" role="button">Back</a>
            {% endif %}
            <br>
            {% if form %}
                <form action = "" method="POST">
                    {%csrf_token%}
                    <table>
                        {{form.as_table}}
                    </table>
                    <input type="submit" name="send" class="btn btn-primary" value="Send to automate">
                    {% if new %}
                        <input type="submit" name="save" class="btn btn-primary" value="Save">
                    {% else %}
                        <input type="submit" name="save" class="btn btn-secondary" value="Update">
                        <input type="submit" name="delete" class="btn btn-danger" value="Delete">
                    {% endif %}
                </form>
            {% else %}
                <b> Setting Name: </b>
                <form action = "{% url 'chargeur:load' %}" method="POST">
                    {% csrf_token %}
                    <select name="setting_id" required>
                        {% for setting in setting_list %}
                        <option value="{{setting.pk}}">{{setting.setting_name}}</option>
                        {% endfor %}
                    </select>
                    <input type="submit" name="load" value="Load" class="btn btn-primary">
                </form>
            {% endif %}
            {% if messages %}
            <ul class="messages">
                {% for message in messages %}
                <li{% if message.tags %} class="{{ message.tags }}"{% endif %} style='color:green'>{{ message }}</li>
                {% endfor %}
            </ul>
            {% endif %}
        </div>
    </div>
</div>

{% if machine_state == "DETECT_CHAIN" or machine_state == "START_SYNCH" or machine_state == "STARTING" %}
<script type="text/javascript">
setTimeout(function(){
    window.location.href = "";
}, 5000);
</script>
{% endif %}

TB/Informatique/MCA/chargeur/templates/chargeur/navbar.html
{% load bootstrap4 %}
{% bootstrap_css %}
{% bootstrap_javascript jquery='full' %}
{% load static %}

<link rel="stylesheet" type="text/css" href="{% static 'polls/style.css' %}">

<nav class="navbar navbar-expand-md navbar-dark sticky-top bg-primary">
    <a class="navbar-brand" href="{% url 'chargeur:load' %}">
    	<img src="{% static 'img/logo-polytype.png' %}"  width="200"/>
    </a>
    <div class="collapse navbar-collapse" id="navBar">
        <ul class="navbar-nav mr-auto">
            <li class="nav-item {% if active == 'index' %} active {% endif %}">
                <a class="nav-link" href="{% url 'chargeur:load' %}">Home</a>
            </li>
            <li class="nav-item {% if active == 'recipe' %} active {% endif %}">
                <a class="nav-link" href="{% url 'chargeur:load_recipe' %}">Recipe</a>
            </li>
            <li class="nav-item {% if active == 'stats' %} active {% endif %}">
                <a class="nav-link" href="{% url 'chargeur:stats' %}">Statistics</a>
            </li>
            <li class="nav-item {% if active == 'errors' %} active {% endif %}">
                <a class="nav-link" href="{% url 'chargeur:error' %}">Errors</a>
            </li>
        </ul>
        <span style="color:white">{% now "D d/m/Y H:i" %}</span>
        
    </div>
</nav>

TB/Informatique/MCA/chargeur/templates/chargeur/recipe.html
{% include "chargeur/navbar.html" %}
{% load bootstrap4 %}
{% bootstrap_css %}
<div class="container-fluid">
    <div class="row">
        <div class="col-6">
        <h2> Recipe </h2>
        {% if new %}
            <a class="btn btn-primary" href="{% url 'chargeur:load_recipe' %}" role="button">Load</a>
        {% else %}
            <a class="btn btn-primary" href="{% url 'chargeur:recipe' %}" role="button">New</a>
        {% endif %}
        {% if form %}
            <a class="btn btn-secondary" href="{% url 'chargeur:load_recipe' %}" role="button">Back</a>
        {% endif %}
        <br>
        {% if form %}
            <form action="" method="POST">
                {% csrf_token %}
                <table>
                    {{form.as_table}}
                </table>
                <input type="submit" name="send" class="btn btn-primary" value="Send to automate">
                {% if new %}
                    <input type="submit" name="save" class="btn btn-primary" value="Save">
                {% else %}
                    <input type="submit" name="save" class="btn btn-secondary" value="Update">
                    <input type="submit" name="delete" class="btn btn-danger" value="Delete">
                {% endif %}
            </form>
        {% else %}
            <b> Recipe Name: </b>
            <form action="{% url 'chargeur:load_recipe' %}" method="POST">
                {% csrf_token %}
                <select name="recipe_id" required>
                    {% for recipe in recipe_list %}
                    <option value="{{recipe.pk}}">{{recipe.recipe_name}}</option>
                    {% endfor %}
                </select>
                <input type="submit" value="Load" class="btn btn-primary">
             </form>
        {% endif %}
        {% if messages %}
            <ul class="messages">
                {% for message in messages %}
                <li{% if message.tags %} class="{{message.tags}}" {% endif %} style="color:green"> {{message}}</li>
                {% endfor %}
            </ul>
        {% endif %}
        </div>
        {% if curr_recipe %}
        <div class="col-6">
            <h2>Current Recipe</h2>
            <table>
                <tbody>
                    <tr>
                        <th>Critical low speed value: </th>
                        <td>{{curr_recipe.crit_low_speed}} t/min</td>
                    </tr>
                    <tr>
                        <th>Speed correction on conveyor: </th>
                        <td>{{curr_recipe.conveyor_speed_correction}}x </td>
                    </tr>
                    <tr>
                        <th>Charging speed factor below critical speed: </th>
                        <td>{{curr_recipe.charging_factor_below_speed}}x</td>
                    </tr>
                    <tr>
                        <th>Wait time below critical speed: </th>
                        <td>{{curr_recipe.wait_time_below_speed}}°</td>
                    </tr>
                    <tr>
                        <th>Allowed speed change: </th>
                        <td>{{curr_recipe.allowed_speed_change}}%</td>
                    </tr>
                    <tr>
                        <th>Start offset angle: </th>
                        <td>{{curr_recipe.start_offset_angle}}° </td>
                    </tr>
                    <tr>
                        <th>Loading marging factor: </th>
                        <td>{{curr_recipe.loading_marging_factor}}</td>
                    </tr>
                    <tr>
                        <th>Positive angle error allowed: </th>
                        <td>{{curr_recipe.allowed_pos_angle_error}}° </td>
                    </tr>
                    <tr>
                        <th>Negative angle error allowed: </th>
                        <td>{{curr_recipe.allowed_neg_angle_error}}° </td>
                    </tr>
                </tbody>   
            </table>
        </div>
        {% endif %}
    </div>
</div>